Attribute VB_Name = "mdMMClient2Server"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Form:    mdMMClient2Server.frm                                *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************

Function getStringAllItemsInFolderContactsOnFileSystem(ByRef contactsFolders() As FolderInfo, _
                                                       ByRef folderType As Integer)
                                                       
printDebugMessage "Enter getStringAllItemInFolderContacts method"

Dim size As Integer
size = UBound(contactsFolders())
Dim objFolder As Outlook.MAPIFolder
Dim objItems As Outlook.Items
Dim intNumItems As Integer
Dim ret As String
Dim countItems As Long
Dim objFSO As Object
Dim fsoStream As Object
Dim kk As Integer
Dim Contact As Object 'for Redemption
Dim objItem As Outlook.ContactItem

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

START_ROOT = TAG_START_CONTACTS
END_ROOT = TAG_END_CONTACTS
INTERNAL_START_ROOT = TAG_START_CONTACT
INTERNAL_END_ROOT = TAG_END_CONTACT

Dim i As Integer
intNumItems = 0
Dim currentDir As String
Set objFSO = CreateObject("Scripting.FileSystemObject")

Dim text As String
text = WAIT_PREPARING
Dim filename As String

'enter in directory to store contacts items
If Not mdFileSystem.doesFolderExist(DIR_ALL_ITEM_CONTACTS) Then
    MkDir DIR_ALL_ITEM_CONTACTS
    ChDir DIR_ALL_ITEM_CONTACTS
Else
    ChDir DIR_ALL_ITEM_CONTACTS
End If

currentDir = CurDir

For i = 1 To size
            
        Set objFolder = mdVariables.nameSpace.GetFolderFromID(contactsFolders(i).EntryID)
        ChangeStatusBar text + contactsFolders(i).name
        intNumItems = intNumItems + objFolder.Items.Count
        ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
        Set objItems = objFolder.Items
    
    For countItems = 1 To objFolder.Items.Count
        
        On Error Resume Next
        Err.Clear
        
        Set Contact = New Redemption.SafeContactItem
        If objItems Is Nothing Then
            logToDebug "The folder " & objFolder.name & " is empty"

        ElseIf objItems.Item(countItems).Class = olDistributionList Then
            intNumItems = intNumItems - 1
        Else
        
            Set objItem = objItems.Item(countItems)
            filename = objItem.EntryID
            Contact.Item = objItem
            printDebugMessage "Item: " + Contact.Subject + " " + Contact.Email1Address
                                           
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CON Then
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        If props(K, 0) = "Email1Address" Then
                            props(K, 1) = Contact.Email1Address
                        Else
                        props(K, 1) = mdActions.getItemPropertyValue( _
                            Contact, mdVariables.contactsProperties(K).Property)
                            ' To get item without conversion
                            ' objItem, mdVariables.contactsProperties(K).Property)
                        End If

                    End If
                Next K

                ret = ""
                ret = ret + INTERNAL_START_ROOT

                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"
               Next K

               ret = ret + "<Folder>" + contactsFolders(i).CompletePath + "</Folder>"
               ret = ret + INTERNAL_END_ROOT

                ChDrive (mdMMVariables.AppDrive)
                ChDir currentDir

               ' For proper encoding writing on filesystem in unicode character set
'               'Set fsoStream = objFSO.CreateTextFile(filename, True, True)
                Set fsoStream = objFSO.CreateTextFile(filename, True)
                fsoStream.WriteLine ret
                fsoStream.Close
                
                Set fsoStream = Nothing
                Set objItem = Nothing
                'Set Contact = Nothing   ' ODDLY, THIS INCREMENT THE MEMORY USAGE!!! AVOID!!!
                ret = vbNullString
                                 
        End If
    ChangeStatusBar text + contactsFolders(i).name + " " + "(" + Trim(Str(countItems)) + "/" + Trim(Str(objFolder.Items.Count)) + ")"
    logToDebug Str(countItems)
    Next countItems
    
Next i

    Erase props()
    ChDir ".."
    printDebugMessage "Exit getStringAllItemInFOlderContacts method"
    getStringAllItemsInFolderContactsOnFileSystem = ""

End Function
                     
Public Sub populateRecProps(ByRef RecProps As Variant, ByVal objItems As Outlook.AppointmentItem)
            
    printDebugMessage "Enter populateRecProps method"
    Dim objItemRecurrence As Object
    Set objItemRecurrence = objItems.GetRecurrencePattern
    
    Dim recurrenceType As Long
    Dim interval As Long
    Dim monthOfYear As Long
    Dim dayOfMonth As Long
    Dim dayOfWeekMask As Long
    Dim instance As Long
    Dim patternStartDate As String
    Dim patterEndDate As String
    Dim noEndDate As Boolean
    Dim startAppointment As Date
    Dim occurrences As Long
    
    Dim x, y, z As Integer
    Dim changeDay, isBackward, changeYearBackward, changeYearForward   As Boolean
    changeDay = False
    isBackward = False
    changeYearBackward = False
    changeYearForward = False
    
    startAppointment = objItems.Start
    x = DatePart("h", startAppointment)
    startAppointment = mdMMTimeUtils.LocalToUTC_Date(startAppointment)
    y = DatePart("h", startAppointment)
    recurrenceType = objItemRecurrence.recurrenceType
    
    interval = objItemRecurrence.interval
    dayOfMonth = objItemRecurrence.dayOfMonth
    monthOfYear = objItemRecurrence.monthOfYear
    dayOfWeekMask = objItemRecurrence.dayOfWeekMask
    instance = objItemRecurrence.instance
    patternStartDate = mdMMTimeUtils.LocalToUTC(objItemRecurrence.patternStartDate)
    patterEndDate = mdMMTimeUtils.LocalToUTC(objItemRecurrence.PatternEndDate)
    noEndDate = objItemRecurrence.noEndDate
    occurrences = objItemRecurrence.occurrences
                                                    
    If x - y < 0 Then
        z = (x - y) * (-1)
    Else
        z = x - y
    End If
    
    If z > 12 Then
        changeDay = True
    Else
        changeDay = False
    End If
    
    If changeDay = True Then
        If getTimeZoneInfo = True Then
            isBackward = True
        Else
            isBackward = False
        End If
            
    End If
    
    'Assing every Value to for the property
     'Assing every Value to for the property
    RecProps(0, 0) = "RecurrenceType"
    RecProps(0, 1) = recurrenceType
        
    RecProps(1, 0) = "Interval"
    RecProps(1, 1) = interval
        
    If dayOfMonth <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfMonth = dayOfMonth - 1
                    If dayOfMonth = 0 Then
                        If monthOfYear = 5 Or monthOfYear = 7 Or monthOfYear = 10 Then
                            ' if May, July, October the month before has 30 days
                            dayOfMonth = 30
                        Else
                            dayOfMonth = 31
                        End If
                            changeYearBackward = True
                    End If
                Else
                    dayOfMonth = dayOfMonth + 1
                    If dayOfMonth > 31 Or (dayOfMonth = 31 And (monthOfYear = 4 Or monthOfYear = 6 Or monthOfYear = 9)) Then
                        dayOfMonth = 1
                        changeYearForward = True
                    End If
                End If
            End If
            RecProps(2, 0) = "DayOfMonth"
            RecProps(2, 1) = dayOfMonth
            
     Else
        RecProps(2, 0) = "DayOfMonth"
        RecProps(2, 1) = 0
        
     End If
    
     If monthOfYear <> 0 Then
            If changeYearBackward = True Then
                monthOfYear = monthOfYear - 1
                If monthOfYear = 0 Then
                    monthOfYear = 12
                End If
            ElseIf changeYearForward = True Then
                monthOfYear = monthOfYear + 1
                If monthOfYear > 12 Then
                    monthOfYear = 1
                End If
            End If
            RecProps(3, 0) = "MonthOfYear"
            RecProps(3, 1) = monthOfYear
      Else
        RecProps(3, 0) = "MonthOfYear"
        RecProps(3, 1) = 0
            
      End If
    
      If dayOfWeekMask <> 0 Then
            If changeDay = True Then
                If isBackward = True Then
                    dayOfWeekMask = convertDayOfWeekMaskBackward(dayOfWeekMask)
                Else
                    dayOfWeekMask = convertDayOfWeekMaskForward(dayOfWeekMask)
                End If
            End If
            RecProps(4, 0) = "DayOfWeekMask"
            RecProps(4, 1) = dayOfWeekMask
     Else
        RecProps(4, 0) = "DayOfWeekMask"
        RecProps(4, 1) = 0
     End If
     
     If instance <> 0 Then
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = instance
            
     Else
        RecProps(5, 0) = "Instance"
        RecProps(5, 1) = 0
     End If
     
     RecProps(6, 0) = "PatternStartDate"
     'check if patterStartDate is > of limit 40000101 so put to Empty
     If mdActions.limitMaxDate > objItemRecurrence.patternStartDate Then
        RecProps(6, 1) = patternStartDate
     Else
        RecProps(6, 1) = ""
     End If
     
     RecProps(7, 0) = "PatternEndDate"
     If mdActions.limitMaxDate > objItemRecurrence.PatternEndDate Then
        RecProps(7, 1) = patterEndDate
     Else
        RecProps(7, 1) = ""
     End If
     
     RecProps(8, 0) = "NoEndDate"
     If (noEndDate = True) Then
        RecProps(8, 1) = 1
     Else
        RecProps(8, 1) = 0
     End If
     
     RecProps(9, 0) = "Occurrences"
     RecProps(9, 1) = occurrences
          
     
     printDebugMessage "Exit populateRecProps method"

End Sub

Public Function getRecurrenceValue(ByRef RecProps() As Variant, ByVal propertyName As String)

    Dim i, up As Integer
    up = UBound(RecProps)
    For i = 0 To up
        If RecProps(i, 0) = propertyName Then
            
            getRecurrenceValue = RecProps(i, 1)
            Exit Function
        End If
        
    Next i

End Function

Public Sub setAllDayEvent(ByRef objAppointment As Redemption.SafeAppointmentItem)

    mdMMVariables.isAllDayEvent = False
    Dim i, up As Integer
    up = UBound(mdVariables.calendarProperties)
    Dim ret As String
    For i = 0 To up
        If mdVariables.calendarProperties(i).Property = "AllDayEvent" Then
            mdMMVariables.isAllDayEvent = CBool(mdActions.getItemPropertyValue(objAppointment, "AllDayEvent"))
            Exit Sub
        End If
    
    Next i

End Sub

Function getStringAllItemsInFolderOnFileSystem(ByRef objFolder As Outlook.MAPIFolder, ByRef folderType As Integer)
    'prepare the file NAME_ALL_FILE, listing all the items in the olFolder objFolder

printDebugMessage "Enter getStringAllItemsInFolder method"

Dim objItems As Outlook.Items
Dim objItemRecurrence As Object
Dim countItems As Long
Dim writingLine As String
Dim objFSO As Object
Dim fsoStream As Object

Dim objAppointment As Object
Dim objTask As Object
Dim objItem As Object

Dim RedMessage As Redemption.MessageItem
Dim RedUtils As Redemption.MAPIUtils

Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String

Dim currentDir As String
'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
        
    If Not mdFileSystem.doesFolderExist(DIR_ALL_ITEM_CALENDARS) Then
        MkDir DIR_ALL_ITEM_CALENDARS
        ChDir DIR_ALL_ITEM_CALENDARS
    Else
        ChDir DIR_ALL_ITEM_CALENDARS
    End If
    
Case mdVariables.FOLDER_TYPE_TASK
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
        
    If Not mdFileSystem.doesFolderExist(DIR_ALL_ITEM_TASKS) Then
        MkDir DIR_ALL_ITEM_TASKS
        ChDir DIR_ALL_ITEM_TASKS
    Else
        ChDir DIR_ALL_ITEM_TASKS
    End If
    
Case mdVariables.FOLDER_TYPE_NOTE
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    
    If Not mdFileSystem.doesFolderExist(DIR_ALL_ITEM_NOTES) Then
        MkDir DIR_ALL_ITEM_NOTES
        ChDir DIR_ALL_ITEM_NOTES
    Else
        ChDir DIR_ALL_ITEM_NOTES
    End If
End Select

currentDir = CurDir

Dim intNumItems As Integer
intNumItems = objFolder.Items.Count
Dim numItems As String
numItems = "" & intNumItems
Set objFSO = CreateObject("Scripting.FileSystemObject")
Dim message As Object

Dim text As String
text = WAIT_PREPARING

Dim ret As String
                 
    'handle each item
    For countItems = 1 To objFolder.Items.Count
        'error control first
      On Error Resume Next
        Err.Clear
        Set objItems = objFolder.Items
        
        If 0 <> Err.number Then
            logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
        ElseIf objItems Is Nothing Then
            logToDebug "The folder " & objFolder.name & " is empty"
        Else 'all is ok
            If folderType = FOLDER_TYPE_CAL Then
                Dim RecProps() As Variant
                ReDim RecProps(0 To 10, 0 To 1)
                'used for recurrence
                mdMMClient2Server.populateRecProps RecProps, objItems.Item(countItems)
                                                                    
            End If
            
            If folderType = FOLDER_TYPE_CAL Then
                
                'original
                Set objAppointment = New Redemption.SafeAppointmentItem
                Set objItem = objItems.Item(countItems)
                objAppointment.Item = objItem
                printDebugMessage "Item: " + objAppointment.Subject
                'end original
                
                'used for allDayEvent. If set then the startDate and endDate should be without time and with
                ' end date without a day
                mdMMClient2Server.setAllDayEvent objAppointment
                
                                               
            ElseIf folderType = FOLDER_TYPE_TASK Then
                Set objTask = New Redemption.SafeTaskItem
                Set objItem = objItems.Item(countItems)
                objTask.Item = objItem
                printDebugMessage "Item: " + objTask.Subject
            ElseIf folderType = FOLDER_TYPE_NOTE Then
                
                printDebugMessage "Item: " + objItem.Subject
            End If
                    
            
            For K = 1 To UBound(props)
                
               If folderType = FOLDER_TYPE_CAL Then
                    props(K, 0) = mdVariables.calendarProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) Then
                        props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                                          
                    Else
                        props(K, 1) = mdActions.getItemPropertyValue(objAppointment, _
                            mdVariables.calendarProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_TASK Then
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                    
                        props(K, 1) = mdActions.getItemPropertyValue(objTask, _
                            mdVariables.tasksProperties(K).Property)
                    End If
                                    
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    props(K, 0) = mdVariables.notesProperties(K).Property
                    If (props(K, 0) = "Body") Then
                        Set RedUtils = New Redemption.MAPIUtils
                        'RedUtils.MAPIOBJECT = Outlook.Session.MAPIOBJECT
                        Set RedMessage = RedUtils.GetItemFromID(objItems.Item(countItems).EntryID, objItems.Item(countItems).Parent.StoreID)
                        logToDebug RedMessage.Body
                        props(K, 1) = RedMessage.Body
                        'RedMessage = Nothing  'THIS INCREMENT MEMORY USAGE
                        RedUtils = Nothing
                    
                    Else
                        props(K, 1) = mdActions.getItemPropertyValue(objItems.Item(countItems), _
                            mdVariables.notesProperties(K).Property)
                    End If
                End If
                
            Next K
            
            ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
            ' IsRecurring property to True also if it isn't!!
            If folderType = FOLDER_TYPE_TASK Then
                Set objItemRecurrence = objTask.GetRecurrencePattern
                For K = 1 To UBound(props)
                    props(K, 0) = mdVariables.tasksProperties(K).Property
                    
                    If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                        props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                            mdVariables.tasksProperties(K).Property)
                    End If
                Next K
            End If
            
            ret = ""
           
            ret = ret + INTERNAL_START_ROOT
            For K = 1 To UBound(props)
                ret = ret + "<" + CStr(props(K, 0)) + ">"
                'ret = ret + CStr(props(K, 1))
                ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                ret = ret + "</" + CStr(props(K, 0)) + ">"

            Next K
                      
            ret = ret + INTERNAL_END_ROOT
            
            ChDrive (mdMMVariables.AppDrive)
            ChDir currentDir
            
            Set fsoStream = objFSO.CreateTextFile(objItems.Item(countItems).EntryID, True)
            fsoStream.WriteLine ret
            fsoStream.Close
            Set fsoStream = Nothing
            
            Set objItem = Nothing
            Set objAppointment = Nothing
            Set objTask = Nothing
            
            ChangeStatusBar text + objFolder.name + " " + "(" + Trim(Str(countItems)) + "/" + Trim(Str(objFolder.Items.Count)) + ")"
            logToDebug Str(countItems)
        End If
       
    Next
    
    ChDir ".."
    printDebugMessage "Exit getStringAllItemsInFolder method"
End Function

Function getStringNewItemsInFolderContactsOnFileSystem(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)

    printDebugMessage "Enter getStringNewItemsInFolderContacts method"
    
    Dim objItem As Object
    Dim objItemRecurrence As Object
    Dim i As Integer
    
    Dim extraItems As Integer
    extraItems = -1
    Dim extraNew() As Variant
    
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
        
    Dim props() As Variant
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
    Dim INTERNAL_START_ROOT As String
    Dim INTERNAL_END_ROOT As String
           
    Dim totalNumItems As Integer
    totalNumItems = 0
    Dim totalNumItemsForStatusBar As Integer
    totalNumItemsForStatusBar = 0
                  
    Dim text As String
    text = WAIT_PREPARING_NEW
    
    Dim Contact As Object 'for Redemption
    
    Dim objFSO As Object
    Dim fsoStream As Object

    Set objFSO = CreateObject("Scripting.FileSystemObject")
       
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
        
    Dim currentDir As String
    Dim filename As String
    
    On Error GoTo getStringErrorManager
                         
            extraNew = getAllNewItemNameFromFile
            extraItems = UBound(extraNew, 2)
            numItems = UBound(mdVariables.createdListMM, 2)
            
             'enter in directory to store contacts items
            If Not mdFileSystem.doesFolderExist(DIR_NEW_ITEM_CONTACTS) Then
                MkDir DIR_NEW_ITEM_CONTACTS
                ChDir DIR_NEW_ITEM_CONTACTS
            Else
                ChDir DIR_NEW_ITEM_CONTACTS
            End If
                
            currentDir = CurDir
            
            If numItems <> -1 Or extraItems <> -1 Then
                totalNumItems = numItems + 1 + extraItems + 1
                totalNumItemsForStatusBar = numItems + 1 + extraItems + 1
                
                For i = 0 To numItems
                
                    ChangeStatusBar WAIT_PREPARING_NEW + objFolder.name + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(totalNumItemsForStatusBar)) + ")"
                    
                    Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdListMM(0, i))
                                                                     
                    If objItem.Class = olDistributionList Then 'to avoid distribution list
                        logToDebug ("It's a distributionList: not sync - ADD")
                        totalNumItems = totalNumItems - 1
                        
                    Else
                        filename = objItem.EntryID
                        
                        Set Contact = New Redemption.SafeContactItem 'for Redemption
                        Contact.Item = objItem
                        
                        printDebugMessage "Item: " + Contact.Subject
                        
                        For K = 1 To UBound(props)
                            If folderType = FOLDER_TYPE_CON Then
                                props(K, 0) = mdVariables.contactsProperties(K).Property
                                props(K, 1) = mdActions.getItemPropertyValue(Contact, mdVariables.contactsProperties(K).Property)
                            End If
                        
                        Next K
                        ret = ""
                        ret = ret + INTERNAL_START_ROOT
                        ' create all xml structure
                        For K = 1 To UBound(props)
                            ret = ret + "<" + CStr(props(K, 0)) + ">"
                            
                            ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                            ret = ret + "</" + CStr(props(K, 0)) + ">"
        
                        Next K
                            ret = ret + "<Folder>" + mdVariables.createdListMM(1, i) + "</Folder>"
                            
                        ret = ret + INTERNAL_END_ROOT
                                                                                        
                        Set objItem = Nothing
                        
                        ChDrive (mdMMVariables.AppDrive)
                        ChDir currentDir
                        
                        Set fsoStream = objFSO.CreateTextFile(filename, True)
                        fsoStream.WriteLine ret
                        fsoStream.Close
                        Set fsoStream = Nothing
                                                
                    
                    End If
                Next
                
                For i = 0 To extraItems
                    ChangeStatusBar WAIT_PREPARING_NEW + GetLastToken(extraNew(1, i)) + " " + "(" + Trim(Str(newItems + i + 1)) + "/" + Trim(Str(totalNumItemsForStatusBar)) + ")"
                    
                    Set objItem = mdVariables.nameSpace.GetItemFromID(extraNew(0, i))
                    
                    If objItem.Class = olDistributionList Then 'to avoid distribution list
                        logToDebug ("It's a extra distributionList: not sync - ADD")
                        totalNumItems = totalNumItems - 1
                        
                    Else
                    
                    filename = Contact.EntryID
                                                                                              
                    Set Contact = New Redemption.SafeContactItem 'for Redemption
                    Contact.Item = objItem
                    
                    printDebugMessage "Item: " + Contact.Subject
                    
                    For K = 1 To UBound(props)
                            If folderType = FOLDER_TYPE_CON Then
                                props(K, 0) = mdVariables.contactsProperties(K).Property
                                props(K, 1) = mdActions.getItemPropertyValue(Contact, mdVariables.contactsProperties(K).Property)
                            End If
                        
                        Next K
                                                          
                        ret = ""
                        ret = ret + INTERNAL_START_ROOT
                        ' create all xml structure
                        For K = 1 To UBound(props)
                            ret = ret + "<" + CStr(props(K, 0)) + ">"
                            ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                            ret = ret + "</" + CStr(props(K, 0)) + ">"
        
                        Next K
                            ret = ret + "<Folder>" + extraNew(1, i) + "</Folder>"
                            
                        ret = ret + INTERNAL_END_ROOT
                        
                        Set objItem = Nothing
                        
                        ChDrive (mdMMVariables.AppDrive)
                        ChDir currentDir
                        
                        Set fsoStream = objFSO.CreateTextFile(filename, True)
                        fsoStream.WriteLine ret
                        fsoStream.Close
                        
                        Set fsoStream = Nothing
                        
                    End If
                Next
                
            End If
            logToDebug ret
        
        getStringNewItemsInFolderContactsOnFileSystem = ret
            
getStringErrorManager_Exit:
        ChDir ".."
        printDebugMessage "Exit getStringNewItemsInFolderContacts method"
        Exit Function
            
getStringErrorManager:
        Dim actionToDo As Integer
        
        actionToDo = mdErrors.fixErrors(Err.number)
        Select Case actionToDo
        Case 0
            GoTo getStringErrorManager_Exit
        Case 1
            Resume
        Case 2
            Resume Next
        End Select
          
        
End Function

Function getStringNewItemsInFolderOnFileSystem(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)

printDebugMessage "Enter getStringNewItemsInFolder method"
Dim objItem As Object
Dim objItemRecurrence As Object
Dim objFSO As Object
Dim fsoStream As Object

Dim i As Integer

Dim ret As String
ret = ""
Dim numItems As Integer
numItems = -1
    
Dim objAppointment As Object 'for Redemption
Dim objTask As Object
        
Dim props() As Variant
Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String
Dim INTERNAL_START_ROOT As String
Dim INTERNAL_END_ROOT As String
       
Dim currentDir As String
       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    'writingLine = "Calendar"
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
    INTERNAL_START_ROOT = TAG_START_CALENDAR
    INTERNAL_END_ROOT = TAG_END_CALENDAR
    ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
    
    If Not mdFileSystem.doesFolderExist(DIR_NEW_ITEM_CALENDARS) Then
        MkDir DIR_NEW_ITEM_CALENDARS
        ChDir DIR_NEW_ITEM_CALENDARS
    Else
        ChDir DIR_NEW_ITEM_CALENDARS
    End If
        
Case mdVariables.FOLDER_TYPE_TASK
    'writingLine = "Task"
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    INTERNAL_START_ROOT = TAG_START_TASK
    INTERNAL_END_ROOT = TAG_END_TASK
    ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
    
    If Not mdFileSystem.doesFolderExist(DIR_NEW_ITEM_TASKS) Then
        MkDir DIR_NEW_ITEM_TASKS
        ChDir DIR_NEW_ITEM_TASKS
    Else
        ChDir DIR_NEW_ITEM_TASKS
    End If
    
Case mdVariables.FOLDER_TYPE_NOTE
    'writingLine = "Notes"
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES
    INTERNAL_START_ROOT = TAG_START_NOTE
    INTERNAL_END_ROOT = TAG_END_NOTE
    ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
    
    If Not mdFileSystem.doesFolderExist(DIR_NEW_ITEM_NOTES) Then
        MkDir DIR_NEW_ITEM_NOTES
        ChDir DIR_NEW_ITEM_NOTES
    Else
        ChDir DIR_NEW_ITEM_NOTES
    End If
        
End Select
        
currentDir = CurDir
        
Dim RedUtils As Redemption.MAPIUtils
Dim RedMessage As Redemption.MessageItem

Set objFSO = CreateObject("Scripting.FileSystemObject")
Dim text As String
text = WAIT_PREPARING
    
On Error GoTo getStringErrorManager
                
        numItems = UBound(mdVariables.createdList)
        If numItems <> -1 And mdVariables.createdList(0) <> "-1" Then
        'If numItems <> -1 Then
            Dim st As String
            st = Str(numItems + 1)
        
            For i = 0 To numItems
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.createdList(i))
                
                ChangeStatusBar WAIT_PREPARING_NEW + objFolder.name + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(numItems + 1)) + ")"
                
                If folderType = FOLDER_TYPE_CAL Then
                    Dim RecProps() As Variant
                    ReDim RecProps(0 To 10, 0 To 1)
                    'used for recurrence
                    mdMMClient2Server.populateRecProps RecProps, objItem
                                                                
                End If
                
                If folderType = FOLDER_TYPE_CAL Then
                    Set objAppointment = New Redemption.SafeAppointmentItem
                    
                    objAppointment.Item = objItem
                    printDebugMessage "Item: " + objAppointment.Subject
                    
                    'used for allDayEvent. If set then the startDate and endDate should be without time and with
                    ' end date without a day
                    mdMMClient2Server.setAllDayEvent objAppointment
                    
                ElseIf folderType = FOLDER_TYPE_TASK Then
                    Set objTask = New Redemption.SafeTaskItem
                    objTask.Item = objItem
                    printDebugMessage "Item: " + objTask.Subject
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    printDebugMessage "Item: " + objItem.Subject
                
                End If
            
                               
                For K = 1 To UBound(props)
                    If folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                            
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objAppointment, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                           
                            props(K, 1) = mdActions.getItemPropertyValue(objTask, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                         If (props(K, 0) = "Body") Then
                            
                            Set RedUtils = New Redemption.MAPIUtils
                            Set RedMessage = RedUtils.GetItemFromID(objItem.EntryID, objItem.Parent.StoreID)
                            logToDebug RedMessage.Body
                            props(K, 1) = RedMessage.Body
                            'RedMessage = Nothing
                            'RedUtils = Nothing
                            
                        
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                        End If
                    End If
                
                Next K
                  
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                                    
                ret = ""
                ret = ret + INTERNAL_START_ROOT
                ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                
                ret = ret + INTERNAL_END_ROOT
                Set objAppointment = Nothing
                Set objTask = Nothing
                
                ChDrive (mdMMVariables.AppDrive)
                ChDir currentDir
                
                Set fsoStream = objFSO.CreateTextFile(objItem.EntryID, True)
                fsoStream.WriteLine ret
                fsoStream.Close
                Set fsoStream = Nothing
                                               
            Next
            logToDebug Str(i + 1)
        End If
    
getStringErrorManager_Exit:
    printDebugMessage "Exit getStringNewItemsInFolder method"
    ChDir ".."
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
      
    
End Function

Function getStringModItemsInFolderContactsOnFileSystem(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)
    'used to sync contacts subfolders
    
    printDebugMessage "Enter getStringModItemsInFolderContacts method"
    Dim objItem As Object
    Dim objItemRecurrence As Object
    Dim i As Integer
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim Contact As Object 'for Redemption
    
    Dim props() As Variant
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
    Dim INTERNAL_START_ROOT As String
    Dim INTERNAL_END_ROOT As String
               
    Dim totalNumItems As Integer
    totalNumItems = 0
                   
    Dim text As String
    text = WAIT_PREPARING_UPDATE
    ChangeStatusBar text
    
    Dim objFSO As Object
    Dim fsoStream As Object

    Set objFSO = CreateObject("Scripting.FileSystemObject")
    Dim currentDir As String
                       
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
    INTERNAL_START_ROOT = TAG_START_CONTACT
    INTERNAL_END_ROOT = TAG_END_CONTACT
    ReDim props(0 To UBound(mdVariables.contactsProperties), 0 To 1)
            
    Dim itemDirectory As String
        
    On Error GoTo getStringErrorManager
       
        numItems = UBound(mdVariables.modifiedListMM, 2)
        
        'enter in directory to store contacts items
        If Not mdFileSystem.doesFolderExist(DIR_MOD_ITEM_CONTACTS) Then
            MkDir DIR_MOD_ITEM_CONTACTS
            ChDir DIR_MOD_ITEM_CONTACTS
        Else
            ChDir DIR_MOD_ITEM_CONTACTS
        End If
         
        currentDir = CurDir
        
        If numItems <> -1 Then
            
            totalNumItems = numItems + 1
           
            For i = 0 To numItems
                
                'to set status bar
                itemDirectory = GetLastToken(mdVariables.modifiedListMM(1, i))
                If itemDirectory = "/" Or itemDirectory = "" Then
                    itemDirectory = objFolder.name
                End If
                                
                ChangeStatusBar WAIT_PREPARING_UPDATE + itemDirectory + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(totalNumItems)) + ")"
                
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdVariables.modifiedListMM(0, i))
                
                 If objItem.Class = olDistributionList Then 'to avoid distribution list
                    logToDebug ("It's a extra distributionList: not sync - MOD")
                    totalNumItems = totalNumItems - 1
                    
                 Else
                    Set Contact = New Redemption.SafeContactItem
                    Contact.Item = objItem
                    printDebugMessage "Item: " + Contact.Subject
                    For K = 1 To UBound(props)
                        
                        props(K, 0) = mdVariables.contactsProperties(K).Property
                        props(K, 1) = mdActions.getItemPropertyValue(Contact, mdVariables.contactsProperties(K).Property)
                        
                    Next K
                    
                    ret = ""
                    ret = ret + INTERNAL_START_ROOT
                   ' create all xml structure
                    For K = 1 To UBound(props)
                        ret = ret + "<" + CStr(props(K, 0)) + ">"
                        ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                        ret = ret + "</" + CStr(props(K, 0)) + ">"
    
                    Next K
                    
                    ret = ret + "<Folder>" + mdVariables.modifiedListMM(1, i) + "</Folder>"
                    ret = ret + INTERNAL_END_ROOT
                                
                    ChDrive (mdMMVariables.AppDrive)
                    ChDir currentDir
                    
                    Set fsoStream = objFSO.CreateTextFile(Contact.EntryID, True)
                    fsoStream.WriteLine ret
                    fsoStream.Close
                    Set fsoStream = Nothing
                                        
                    Set objItem = Nothing
                    
                End If
                
            Next
            
           
        End If
    
        logToDebug ret
            
getStringModItemsInFolderContactsOnFileSystem = ret
        
getStringErrorManager_Exit:
    ChDir ".."
    printDebugMessage "Exit getStringModItemsInFolderContacts method"
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
   
End Function


Function getStringModItemsInFolderOnFileSystem(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)
    
    printDebugMessage "Enter getStringModItemsInFolder method"
    Dim objItem As Object
    Dim objItemRecurrence As Object
    Dim objFSO As Object
    Dim fsoStream As Object

    Dim i As Integer
    
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim objAppointment As Object 'for Redemption
    Dim objTask As Object

    Dim props() As Variant
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
    Dim INTERNAL_START_ROOT As String
    Dim INTERNAL_END_ROOT As String
    Dim currentDir As String
    Dim RedUtils As Redemption.MAPIUtils
    Dim RedMessage As Redemption.MessageItem
                                           
    Select Case folderType
    Case mdVariables.FOLDER_TYPE_CAL
        'writingLine = "Calendar"
        START_ROOT = TAG_START_CALENDARS
        END_ROOT = TAG_END_CALENDARS
        INTERNAL_START_ROOT = TAG_START_CALENDAR
        INTERNAL_END_ROOT = TAG_END_CALENDAR
        ReDim props(0 To UBound(mdVariables.calendarProperties), 0 To 1)
        
        If Not mdFileSystem.doesFolderExist(DIR_MOD_ITEM_CALENDARS) Then
            MkDir DIR_MOD_ITEM_CALENDARS
            ChDir DIR_MOD_ITEM_CALENDARS
        Else
            ChDir DIR_MOD_ITEM_CALENDARS
        End If
       
    Case mdVariables.FOLDER_TYPE_TASK
        'writingLine = "Task"
        START_ROOT = TAG_START_TASKS
        END_ROOT = TAG_END_TASKS
        INTERNAL_START_ROOT = TAG_START_TASK
        INTERNAL_END_ROOT = TAG_END_TASK
        ReDim props(0 To UBound(mdVariables.tasksProperties), 0 To 1)
        
        If Not mdFileSystem.doesFolderExist(DIR_MOD_ITEM_TASKS) Then
            MkDir DIR_MOD_ITEM_TASKS
            ChDir DIR_MOD_ITEM_TASKS
        Else
            ChDir DIR_MOD_ITEM_TASKS
        End If

    
    Case mdVariables.FOLDER_TYPE_NOTE
        'writingLine = "Note"
        START_ROOT = TAG_START_NOTES
        END_ROOT = TAG_END_NOTES
        INTERNAL_START_ROOT = TAG_START_NOTE
        INTERNAL_END_ROOT = TAG_END_NOTE
        ReDim props(0 To UBound(mdVariables.notesProperties), 0 To 1)
        
        If Not mdFileSystem.doesFolderExist(DIR_MOD_ITEM_NOTES) Then
            MkDir DIR_MOD_ITEM_NOTES
            ChDir DIR_MOD_ITEM_NOTES
        Else
            ChDir DIR_MOD_ITEM_NOTES
        End If
        
    End Select
    Set objFSO = CreateObject("Scripting.FileSystemObject")
        
    Dim text As String
    text = WAIT_PREPARING
    
    currentDir = CurDir
    
    On Error GoTo getStringErrorManager
       
        numItems = UBound(mdMMVariables.modItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.modItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
        
            For i = 0 To numItems
                
                ChangeStatusBar WAIT_PREPARING_UPDATE + objFolder.name + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(numItems + 1)) + ")"
            
                Set objItem = mdVariables.nameSpace.GetItemFromID(mdMMVariables.modItems(i))
                If folderType = FOLDER_TYPE_CAL Then
                    Dim RecProps() As Variant
                    ReDim RecProps(0 To 10, 0 To 1)
                   
                    'used for recurrence
                    mdMMClient2Server.populateRecProps RecProps, objItem
                                                                
                End If
                
                 If folderType = FOLDER_TYPE_CAL Then
                    Set objAppointment = New Redemption.SafeAppointmentItem
                    objAppointment.Item = objItem
                    printDebugMessage "Item: " + objAppointment.Subject
                    
                    'used for allDayEvent. If set then the startDate and endDate should be without time and with
                    ' end date without a day
                    mdMMClient2Server.setAllDayEvent objAppointment
                    
                ElseIf folderType = FOLDER_TYPE_TASK Then
                    Set objTask = New Redemption.SafeTaskItem
                    objTask.Item = objItem
                    printDebugMessage "Item: " + objTask.Subject
                ElseIf folderType = FOLDER_TYPE_NOTE Then
                    printDebugMessage "Item: " + objItem.Subject
                End If
                
                For K = 1 To UBound(props)
                   If folderType = FOLDER_TYPE_CAL Then
                        props(K, 0) = mdVariables.calendarProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.calendarProperties(K).Property) = True Then
                            props(K, 1) = mdMMClient2Server.getRecurrenceValue(RecProps, mdVariables.calendarProperties(K).Property)
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objAppointment, _
                                mdVariables.calendarProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_TASK Then
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) = False Then
                          
                            props(K, 1) = mdActions.getItemPropertyValue(objTask, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    ElseIf folderType = FOLDER_TYPE_NOTE Then
                        props(K, 0) = mdVariables.notesProperties(K).Property
                        If (props(K, 0) = "Body") Then
                            Set RedUtils = New Redemption.MAPIUtils
                            Set RedMessage = RedUtils.GetItemFromID(objItem.EntryID, objItem.Parent.StoreID)
                            logToDebug RedMessage.Body
                            props(K, 1) = RedMessage.Body
                            'RedMessage = Nothing
                            'RedUtils = Nothing
                        
                        Else
                            props(K, 1) = mdActions.getItemPropertyValue(objItem, mdVariables.notesProperties(K).Property)
                        End If
                    End If
                
                Next K
                
                ' Check if is recurrence for task here because when a GetRecurrencePattern is called on task it set
                ' IsRecurring property to True also if it isn't!!
                If folderType = FOLDER_TYPE_TASK Then
                    Set objItemRecurrence = objItem.GetRecurrencePattern
                    For K = 1 To UBound(props)
                        props(K, 0) = mdVariables.tasksProperties(K).Property
                        
                        If isPropertyInRecurrenceObject(mdVariables.tasksProperties(K).Property) Then
                            props(K, 1) = mdActions.getItemPropertyValue(objItemRecurrence, _
                                mdVariables.tasksProperties(K).Property)
                        End If
                    Next K
                End If
                
                ret = ""
                ret = ret + INTERNAL_START_ROOT
               ' create all xml structure
                For K = 1 To UBound(props)
                    ret = ret + "<" + CStr(props(K, 0)) + ">"
                    ret = ret + replaceMinorAndMajorAndAmp(CStr(props(K, 1)))
                    ret = ret + "</" + CStr(props(K, 0)) + ">"

                Next K
                ret = ret + INTERNAL_END_ROOT
                
                Set objTask = Nothing
                Set objAppointment = Nothing
                
                ChDrive (mdMMVariables.AppDrive)
                ChDir currentDir
                
                Set fsoStream = objFSO.CreateTextFile(objItem.EntryID, True)
                fsoStream.WriteLine ret
                fsoStream.Close
                Set fsoStream = Nothing
                
                logToDebug Str(i)
            Next
            
        End If
        
getStringErrorManager_Exit:
    
    printDebugMessage "Exit getStringModItemsInFolder method"
    ChDir ".."
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
   
End Function

Function getStringDelItemsInFolderContacts(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)
        
    printDebugMessage "Enter getStringDelItemsInFolderContacts method"
    
    Dim objItem As Object
    Dim i As Integer
    Dim ret As String
    ret = ""
    Dim numItems As Integer
    numItems = -1
    
    Dim extraItems As Integer
    extraItems = -1
    
    Dim dirNew As String
    dirNew = DIR_NEW_ITEM_CONTACTS
    Dim dirMod As String
    dirMod = DIR_MOD_ITEM_CONTACTS
    
    Dim totalNumItems As Integer
    totalNumItems = 0
    Dim totalNumItemsForStatusBar As Integer
    totalNumItemsForStatusBar = 0
        
    Dim text As String
    text = WAIT_PREPARING_DELETE
    
    Dim K As Integer
    Dim START_ROOT As String
    Dim END_ROOT As String
       
    Dim extraDeleted() As String
    
    'writingLine = "Contacts"
    START_ROOT = TAG_START_CONTACTS
    END_ROOT = TAG_END_CONTACTS
       
    On Error Resume Next
        
        extraDeleted = getAllNameFolderFromFile
        extraItems = UBound(extraDeleted)
        
        numItems = UBound(mdVariables.deletedListMM, 2)
        
        If numItems <> -1 Or extraItems <> -1 Then
            
            totalNumItems = numItems + 1 + extraItems + 1
            totalNumItemsForStatusBar = numItems + 1 + extraItems + 1
            
            Set objItem = Nothing
        
            For i = 0 To numItems
            
                ChangeStatusBar WAIT_PREPARING_DELETE + objFolder.name + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(totalNumItemsForStatusBar)) + ")"
                
                If mdFileSystem.doesFileExist(dirNew + "\\" + mdVariables.deletedListMM(0, i)) <> True Then
                    ret = ret + "<row>"
                    ret = ret + "<identifier>" + mdVariables.deletedListMM(0, i) + "</identifier>"
                    ret = ret + "</row>"
                Else
                    FileCopy mdMMVariables.AppPath() + dirNew + "\\" + mdVariables.deletedListMM(0, i), _
                             mdMMVariables.AppPath() + dirMod + "\\" + mdVariables.deletedListMM(0, i)
                             
                    Kill mdMMVariables.AppPath() + dirNew + "\\" + mdVariables.deletedListMM(0, i)
                    ChDir mdMMVariables.AppPath()
                    totalNumItems = totalNumItems - 1
                    
                End If
             Next
             
            For i = 0 To extraItems
                
                ChangeStatusBar WAIT_PREPARING_DELETE + objFolder.name + " " + "(" + Trim(Str(numItems + i + 1)) + "/" + Trim(Str(totalNumItemsForStatusBar)) + ")"
                ret = ret + "<row>"
                ret = ret + "<identifier>" + extraDeleted(i) + "</identifier>"
                ret = ret + "</row>"
            Next
            
            If totalNumItems > 0 Then
                Dim st As String
                st = Str(totalNumItems)
                ret = START_ROOT + "<numItems>" + Trim(st) + "</numItems>" + ret + END_ROOT
            End If
            
        End If
    
    logToDebug ret
    getStringDelItemsInFolderContacts = ret
    
getStringErrorManager_Exit:
    printDebugMessage "Exit getStringDelItemsInFolderContacts method"
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    Case 6
        Resume Next
    End Select
        
End Function

Function existsFileInNewItem(ByVal filename As String)



End Function



Function getStringDelItemsInFolder(ByRef folderType As Integer, ByRef objFolder As Outlook.MAPIFolder)
   
printDebugMessage "Enter getStringDelItemsInFolder method"
Dim objItem As Object
Dim i As Integer
Dim ret As String
ret = ""
Dim numItems As Integer
numItems = -1

Dim K As Integer
Dim START_ROOT As String
Dim END_ROOT As String

       
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    START_ROOT = TAG_START_CALENDARS
    END_ROOT = TAG_END_CALENDARS
        
Case mdVariables.FOLDER_TYPE_TASK
    START_ROOT = TAG_START_TASKS
    END_ROOT = TAG_END_TASKS
    
Case mdVariables.FOLDER_TYPE_NOTE
    START_ROOT = TAG_START_NOTES
    END_ROOT = TAG_END_NOTES

End Select
       
On Error GoTo getStringErrorManager
   
        numItems = UBound(mdMMVariables.delItems)
        'If numItems <> -1 Then
        If numItems <> -1 And mdMMVariables.delItems(0) <> "-1" Then
            Dim st As String
            st = Str(numItems + 1)
            ret = START_ROOT
            ret = ret + "<numItems>" + Trim(st) + "</numItems>"
        
            For i = 0 To numItems
                ChangeStatusBar WAIT_PREPARING_DELETE + objFolder.name + " " + "(" + Trim(Str(i + 1)) + "/" + Trim(Str(numItems)) + ")"
                ret = ret + "<row>"
                ret = ret + "<identifier>" + mdMMVariables.delItems(i) + "</identifier>"
                ret = ret + "</row>"
                
            Next
            ret = ret + END_ROOT
        End If
    
    logToDebug ret
    getStringDelItemsInFolder = ret
    
getStringErrorManager_Exit:
    printDebugMessage "Exit getStringDelItemsInFolder method"
    Exit Function
        
getStringErrorManager:
    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo getStringErrorManager_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
    
End Function

Public Function GetLastToken(ByVal new_txt As String) As String
    
Static txt As String
Dim delimiter As String
Dim pos As Integer
Dim substr As String

delimiter = "/"
        
    ' Save new text.
    If new_txt <> "" And new_txt <> "/" Then
    
        txt = new_txt
    
        pos = InStrRev(txt, delimiter)
    
        substr = Left$(txt, pos - 1)
        pos = InStrRev(substr, delimiter)
        If pos < 1 Then
            GetLastToken = ""
        Else
            GetLastToken = Mid$(substr, pos + 1)
        End If
    Else
        GetLastToken = new_text
    End If
    
End Function

